<template>
  <div
    class="relative aspect-[181/93] w-full group h-game-entry"
    :variant="variant"
    :id="ID.SPORT_MODULE_2[gameId]"
  >
    <!-- Background -->
    <div class="w-full h-full overflow-hidden h-game-entry__background pointer-events-none">
      <img
        v-if="!bgImage || bgImage.length <= 0"
        :src="getAssetImage('assets/theme/common/entry/sports/background.png')"
        class="w-full h-full opacity-0 group-hover:opacity-100 h-game-entry__transition"
      />
      <img
        v-else
        :src="bgImage"
        @error="
          (e) =>
            isHandleDefaultImageRender(bgImage)
              ? onErrorDefaultImage(e, bgImage)
              : e.target.remove()
        "
        loading="lazy"
        class="w-full h-full opacity-0 group-hover:opacity-100 h-game-entry__transition"
      />

      <div
        v-if="useSlashes"
        class="w-full h-full group-hover:opacity-[0.35] h-game-entry__transition"
      >
        <img
          :src="getAssetImage('assets/theme/common/entry/slashes.png')"
          class="absolute top-0 right-0 w-8/12 h-full"
        />
      </div>
    </div>

    <div class="absolute top-0 left-0 w-full h-full h-game-entry__overlay pointer-events-none" />

    <!-- Content -->
    <div class="absolute top-0 left-0 flex w-full h-full h-game-entry__content pointer-events-none">
      <div v-if="isUseText" class="relative flex flex-col w-1/2 h-full">
        <div class="relative flex flex-col justify-center w-full h-full">
          <div
            class="flex flex-col w-full h-game-entry__logo-container h-game-entry__transition"
          >
            <div class="flex flex-col items-center justify-center w-full">
              <div class="w-10/12">
                <img
                  v-if="logoImage && logoImage.length > 0"
                  :src="logoImage"
                  @error="(e) => e.target.remove()"
                  loading="lazy"
                  class="self-center object-contain justify-self-center"
                />
                <p
                  v-if="label && label.length > 0"
                  class="font-bold text-center h-game-entry__label"
                >
                  {{ label }}
                </p>
              </div>
            </div>
            <div
              v-if="variant === 'TAGS_WITH_LOGO'"
              class="mb-2 gap-[2%] w-full flex items-center justify-center h-game-entry__tags"
            >
              <img
                v-if="isNew"
                :src="getAssetImage('assets/theme/common/entry/new_icon.png')"
                class="object-contain w-full h-game-entry__tag"
              />
              <img
                v-if="isHot"
                :src="getAssetImage('assets/theme/common/entry/hot_icon.png')"
                class="object-contain w-full h-game-entry__tag"
              />
            </div>
          </div>
        </div>
        <div
          v-if="variant === 'FLOATING_TAGS'"
          class="absolute bottom-[3%] left-[7%] w-[93%]"
        >
          <div class="h-game-entry__tags w-full flex gap-[2%]">
            <img
              v-if="isHot"
              :src="getAssetImage('assets/theme/common/icon/hot_icon.svg')"
              class="object-contain w-full h-game-entry__tag"
            />
            <img
              v-if="isNew"
              :src="getAssetImage('assets/theme/common/icon/new_icon.svg')"
              class="object-contain w-full h-game-entry__tag"
            />
          </div>
        </div>
      </div>
      <div :class="['flex flex-col h-full', isUseText ? 'w-1/2' : 'w-full']">
        <img
          v-if="
            (!floatBgImage || floatBgImage.length <= 0) &&
            personImage &&
            personImage.length > 0
          "
          :src="personImage"
          @error="
            (e) =>
              isHandleDefaultImageRender(personImage, $route.name === 'index')
                ? onErrorDefaultImage(e, personImage, $route.name === 'index')
                : e.target.remove()
          "
          loading="lazy"
          :class="['object-contain self-end mt-auto', {'h-game-entry__person h-game-entry__transition mr-[6%]' : isUseText}]"
        />
        <div
          class="relative flex items-center justify-center w-full h-full"
          v-if="floatBgImage && floatBgImage.length > 0"
        >
          <template v-if="isFloatBackgroundEntry">
            <img
              v-if="floatBgImage && floatBgImage.length > 0"
              :src="floatBgImage"
              @error="
                (e) =>
                  isHandleDefaultImageRender(floatBgImage)
                    ? onErrorDefaultImage(e, floatBgImage)
                    : e.target.remove()
              "
              loading="lazy"
              class="self-center object-contain w-11/12 h-full justify-self-end h-game-entry__floating-bg h-game-entry__transition"
            />
          </template>
          <img
            v-if="personImage && personImage.length > 0"
            :src="personImage"
            @error="
              (e) =>
                isHandleDefaultImageRender(personImage)
                  ? onErrorDefaultImage(e, personImage)
                  : e.target.remove()
            "
            loading="lazy"
            class="justify-self-end self-end object-contain absolute bottom-0 right-[6%] mt-auto h-game-entry__person h-game-entry__transition z-[2]"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { PropType } from "vue";
import commonHelper from "@/utils/commonHelper";

defineProps({
  bgImage: {
    type: String,
    required: false,
  },
  useSlashes: {
    type: Boolean,
    required: false,
    default: false,
  },
  logoImage: {
    type: String,
    required: false,
  },
  floatBgImage: {
    type: String,
    required: false,
  },
  personImage: {
    type: String,
    required: false,
  },
  label: {
    type: String,
    required: false,
  },
  isNew: {
    type: Boolean,
    required: false,
    default: false,
  },
  isHot: {
    type: Boolean,
    required: false,
    default: false,
  },
  variant: {
    type: String as PropType<
      "FLOATING_TAGS" | "TAGS_WITH_LOGO" | "LABEL_AND_PERSON"
    >,
    required: false,
    default: "FLOATING_TAGS",
  },
  isUseText: {
   type: Boolean,
   default: true,
  },
  gameId:{
    type: Number,
    default: 0,
  }
});
const {
  getAssetImage,
  onErrorDefaultImage,
  isHandleDefaultImageRender,
  isFloatBackgroundEntry,
} = commonHelper;
</script>

<style>
:root {
  --h-game-entry-border-radius: 0.5rem; /* 8px */
  --h-game-entry-color: var(--background1);

  --h-game-entry-overlay-background: linear-gradient(
    105.79deg,
    rgba(0, 0, 0, 0) 1.39%,
    rgba(0, 0, 0, 0.6) 94.07%
  );

  --h-game-entry-transition-duration: 700ms;
  --h-game-entry-transform-origin: center;
  --h-game-entry-logo-transform-origin: center;
  --h-game-entry-person-transform-origin: bottom center;

  --h-game-entry-tag-width: 30%;
  --h-game-entry-tag-y-align: center; /* start | end */
  --h-game-entry-tag-x-align: center; /* start | center | end */

  --h-game-entry-float-bg-scale: 1.14;
  --h-game-entry-person-scale: 1.11;
  --h-game-entry-logo-scale: 1.19;

  --h-game-entry-label-size: 1.125rem; /* 18px */
  --h-game-entry-label-color: #fff;
  --h-game-entry-label-align: left;
}
</style>

<style scoped>
.h-game-entry {
  background-color: var(--background5);
  border-radius: var(--h-game-entry-border-radius);
}
.h-game-entry[variant="FLOATING_TAGS"] {
  --h-game-entry-tag-width: 30%;
  --h-game-entry-logo-transform-origin: left;
  --h-game-entry-tag-y-align: center;
  --h-game-entry-tag-x-align: start;
  --h-game-entry-label-align: left;
}
.h-game-entry[variant="LABEL_AND_PERSON"] {
  --h-game-entry-tag-width: 30%;
  --h-game-entry-logo-transform-origin: left;
  --h-game-entry-tag-y-align: center;
  --h-game-entry-tag-x-align: start;
  --h-game-entry-label-align: left;
  --h-game-entry-label-size: 1.5rem;
}

.h-game-entry[variant="TAGS_WITH_LOGO"] {
  --h-game-entry-tag-width: 30%;
  --h-game-entry-logo-transform-origin: center;
  --h-game-entry-tag-y-align: center;
  --h-game-entry-tag-x-align: center;
  --h-game-entry-label-align: center;
}

:deep(.h-game-entry__overlay) {
  background: var(--h-game-entry-overlay-background);
  mix-blend-mode: multiply;
  border-radius: var(--h-game-entry-border-radius);
  overflow: hidden;
}

:deep(.h-game-entry__background) {
  border-radius: var(--h-game-entry-border-radius);
  overflow: hidden;
}
:deep(.h-game-entry__content) {
  border-radius: var(--h-game-entry-border-radius);
}

:deep(.h-game-entry__transition) {
  transition-property: all;
  transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);
  transition-duration: var(--h-game-entry-transition-duration);
  transform-origin: var(--h-game-entry-transform-origin);
}

:deep(.h-game-entry__logo-container) {
  --h-game-entry-transform-origin: var(--h-game-entry-logo-transform-origin);
}

:deep(.h-game-entry__person) {
  --h-game-entry-transform-origin: var(--h-game-entry-person-transform-origin);
}

:deep(.h-game-entry__label) {
  color: var(--h-game-entry-label-color);
  text-align: var(--h-game-entry-label-align);
  font-size: var(--h-game-entry-label-size);
  line-height: 2rem;
}

:deep(.h-game-entry__tag) {
  max-width: var(--h-game-entry-tag-width);
}

:deep(.h-game-entry__tags) {
  justify-content: var(--h-game-entry-tag-x-align);
  align-items: var(--h-game-entry-tag-y-align);
}
.group:hover :deep(.h-game-entry__logo-container) {
  --tw-scale-x: var(--h-game-entry-logo-scale);
  --tw-scale-y: var(--h-game-entry-logo-scale);
  transform: translate(var(--tw-translate-x), var(--tw-translate-y))
    rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
    scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
}

.group:hover :deep(.h-game-entry__person) {
  --tw-scale-x: var(--h-game-entry-person-scale);
  --tw-scale-y: var(--h-game-entry-person-scale);
  transform: translate(var(--tw-translate-x), var(--tw-translate-y))
    rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
    scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
}
.group:hover :deep(.h-game-entry__floating-bg) {
  --tw-scale-x: var(--h-game-entry-float-bg-scale);
  --tw-scale-y: var(--h-game-entry-float-bg-scale);
  transform: translate(var(--tw-translate-x), var(--tw-translate-y))
    rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y))
    scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y));
}
</style>
